<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no" />
    <title>Smart Ghana</title>
    <link rel="stylesheet" href="assets/css/ol.css" />
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css" />
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.min.css" />
    
    <!-- Step 1. Add CSS for the mapping components -->
    <link rel="stylesheet" type="text/css" href="http://js.arcgis.com/3.10/js/esri/css/esri.css">   
    <link rel="stylesheet" type="text/css" href="assets/css/bootstrapmap.css">
    
    <!-- TOC -->
    <link rel="stylesheet" type="text/css" href="assets/css/TableOfContents.css">
    <link rel="stylesheet" href="assets/css/fontello.css">
    
    <style type="text/css">
      body { overflow: hidden; }

      .navbar-offset { margin-top: 50px; }
      #map { position: absolute; top: 50px; bottom: 0px; left: 0px; right: 0px; }
      #map .ol-zoom { font-size: 1.2em; }
      #map {min-height: 100px; max-height: 1000px}

      .zoom-top-opened-sidebar { margin-top: 5px; }
      .zoom-top-collapsed { margin-top: 45px; }

      .mini-submenu{
        display:none;  
        background-color: rgba(255, 255, 255, 0.46);
        border: 1px solid rgba(0, 0, 0, 0.9);
        border-radius: 4px;
        padding: 9px;  
        /*position: relative;*/
        width: 42px;
        text-align: center;
      }

      .mini-submenu-left {
        position: absolute;
        top: 60px;
        left: .5em;
        z-index: 40;
      }
      .mini-submenu-right {
        position: absolute;
        top: 60px;
        right: .5em;
        z-index: 40;
      }

      #map { z-index: 35; }
      
      #mapLegendDiv {
        max-height: 400px;  
        overflow: scroll;
        margin-bottom: 0px;      
      }
        
      #webmap {
        max-height: 500px;  
        overflow: scroll;
        margin-bottom: 0px;      
      }

      .sidebar { z-index: 45; }

      .main-row { position: relative; top: 0; }

      .mini-submenu:hover{
        cursor: pointer;
      }

      .slide-submenu{
        background: rgba(0, 0, 0, 0.45);
        display: inline-block;
        padding: 0 8px;
        border-radius: 4px;
        cursor: pointer;
      }

    </style>
    <!-- Step 3. Add JS to load the responsive map -->
    <script type="text/javascript">
        //var package_path = "//esri.github.com/bootstrap-map-js/src/js";
        var package_path = window.location.pathname.substring(0, window.location.pathname.lastIndexOf('/'));
        var dojoConfig = {
            packages: [{
                name: "application",
                location: package_path + '/assets/js'
            }]
        };
    </script>
    <script type="text/javascript">
        var package_path = window.location.pathname.substring(0, window.location.pathname.lastIndexOf('/'));
        var dojoConfig = {
            // The locationPath logic below may look confusing but all its doing is 
            // enabling us to load the api from a CDN and load local modules from the correct location.
            packages: [{
                name: "application",
                location: package_path + '/assets/js'
            }],
            paths: {
              plugins: location.pathname.replace(/\/[^/]+$/, "") + "/plugins"
            }
        };
    </script>
    <script src="assets/js/windy.js"></script>
    <script src="http://js.arcgis.com/3.10compact"></script>
    <script>
      require(["esri/map",
      	"dojo/_base/lang",
       	"application/TableOfContents", 
        "esri/dijit/Scalebar", 
        "esri/dijit/Legend", 
        "esri/arcgis/utils",  
        "dojo/dom", 
        "dojo/on", 
        "dojo/query", 
        "application/bootstrapmap",
        "dojo/domReady!"], 
      function(Map, lang, TableOfContents, Scalebar, Legend, esriUtils, dom, on, query, BootstrapMap) {  
        "use strict"
        
        var map;
        var scalebar;
        var legend;
        var toc;

        // Load web map automatically when the page loads
        loadWebmap();

        //on(dom.byId("btnWebmap"),"click", loadWebmap);

        //listen for when the title pane has finished expanding to reposition the map div
        //$(".collapse").on('transitionend webkitTransitionEnd',function(e){
        //  map.reposition();
        //});

        function loadWebmap(e) {

          // Get new webmap and extract map and map parts
          resetMap();

          // Webmaps
          var mapDeferred = BootstrapMap.createWebMap("6ae08f8e19d0498b99f14393e1fa9167","map", {
            slider: true,
            nav:false,
            smartNavigation:false          
          });

          mapDeferred.then(function(response) {
            map = response.map;

            // Add titles
            //dom.byId("mapTitle").innerHTML = response.itemInfo.item.title;
            //dom.byId("mapSubTitle").innerHTML = response.itemInfo.item.snippet;
            // Add scalebar and legend
            var layers = esri.arcgis.utils.getLegendLayers(response); 
            var oLayers = response.itemInfo.itemData.operationalLayers;
             
            if(map.loaded){
              initMapParts(layers);
              showTOC(oLayers);
            }
            else{
              on(map,"load",function(){
                initMapParts(layers);
              });
            }

          },function(error){
            alert("Sorry, couldn't load webmap!");
            console.log("Error loading webmap: " & dojo.toJson(error));           
          });
        }
        
        function initMapParts(layers){
         //add scalebar
          scalebar = new Scalebar({
            map:map,
            scalebarUnit: 'english'
          });
          //add legend
          if (legend) {
            legend.map = map;
            legend.refresh(layers);
          }
          else {
            legend = new Legend({
                map:map,
                layerInfos:layers
              },"mapLegendDiv");
            legend.startup();
          }
        }
        
        function showTOC(layers) {
        	toc = new TableOfContents({
                    map: map,
                    layers: layers
                }, "TableOfContents");
                toc.startup();
                
                
                on(dom.byId('theme_form'), 'keyup', lang.hitch(this, function(evt){
                    toc.set("theme", evt.target.value);
                }));
                
                on(dom.byId('visible_form'), 'change', lang.hitch(this, function(evt){
                    toc.set("visible", evt.target.checked);
                }));
        }
         
        function resetMap() {
          if (map) { 
            BootstrapMap.destroy(map);
            map.removeAllLayers();
            map.spatialReference = null;
            map.destroy();
          }
          if (scalebar)
           scalebar.destroy();
          if (legend) {
            dom.byId("mapLegendDiv").innerHTML = "";
          }        
        }

      });
    </script>
    <script type="text/javascript" src="assets/js/ol.js"></script>
    <script type="text/javascript" src="//code.jquery.com/jquery-2.1.1.min.js"></script>
    <script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
    <script type="text/javascript">

      function applyMargins() {
        var leftToggler = $(".mini-submenu-left");
        var rightToggler = $(".mini-submenu-right");
        if (leftToggler.is(":visible")) {
          $("#map #map_zoom_slider")
            .css("margin-left", 0)
            .removeClass("zoom-top-opened-sidebar")
            .addClass("zoom-top-collapsed");
        } else {
          $("#map #map_zoom_slider")
            .css("margin-left", $(".sidebar-left").width())
            .removeClass("zoom-top-opened-sidebar")
            .removeClass("zoom-top-collapsed");
        }
        if (rightToggler.is(":visible")) {
          $("#map .ol-rotate")
            .css("margin-right", 0)
            .removeClass("zoom-top-opened-sidebar")
            .addClass("zoom-top-collapsed");
        } else {
          $("#map .ol-rotate")
            .css("margin-right", $(".sidebar-right").width())
            .removeClass("zoom-top-opened-sidebar")
            .removeClass("zoom-top-collapsed");
        }
      }

      function isConstrained() {
        return $("div.mid").width() == $(window).width();
      }

      function applyInitialUIState() {
        if (isConstrained()) {
          $(".sidebar-left .sidebar-body").fadeOut('slide');
          $(".sidebar-right .sidebar-body").fadeOut('slide');
          $('.mini-submenu-left').fadeIn();
          $('.mini-submenu-right').fadeIn();
        }
      }

      $(function(){
        $('.sidebar-left .slide-submenu').on('click',function() {
          var thisEl = $(this);
          thisEl.closest('.sidebar-body').fadeOut('slide',function(){
            $('.mini-submenu-left').fadeIn();
            applyMargins();
          });
        });

        $('.mini-submenu-left').on('click',function() {
          var thisEl = $(this);
          $('.sidebar-left .sidebar-body').toggle('slide');
          thisEl.hide();
          applyMargins();
        });

        $('.sidebar-right .slide-submenu').on('click',function() {
          var thisEl = $(this);
          thisEl.closest('.sidebar-body').fadeOut('slide',function(){
            $('.mini-submenu-right').fadeIn();
            applyMargins();
          });
        });

        $('.mini-submenu-right').on('click',function() {
          var thisEl = $(this);
          $('.sidebar-right .sidebar-body').toggle('slide');
          thisEl.hide();
          applyMargins();
        });

        $(window).on("resize", applyMargins);

        var map = new ol.Map({
          target: "xmap",
          layers: [
            new ol.layer.Tile({
              source: new ol.source.OSM()
            })
          ],
          view: new ol.View({
            center: [0, 0],
            zoom: 2
          })
        });
        applyInitialUIState();
        applyMargins();
      });
    </script>
  </head>
  <body>
    <div class="container">
      <nav class="navbar navbar-fixed-top navbar-default" role="navigation">
        <div class="container-fluid">
          <!-- Brand and toggle get grouped for better mobile display -->
          <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="http://www.smartghana.org"><b>SmartGhana.org</b> | Location intelligence for Ghana</a>
          </div>
          <!-- Collect the nav links, forms, and other content for toggling -->
          <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <form class="navbar-form navbar-right" role="search">
              <div class="form-group">
                <input type="search" class="form-control" placeholder="Search">
              </div>
              <button type="submit" class="btn btn-default">Go</button>
            </form>
            <ul class="nav navbar-nav navbar-right">
              <li class="dropdown">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">Menu <b class="caret"></b></a>
                <ul class="dropdown-menu">
                  <li><a href="#">Action</a></li>
                  <li><a href="#">Another action</a></li>
                  <li><a href="#">Something else here</a></li>
                  <li class="divider"></li>
                  <li><a href="#">Separated link</a></li>
                </ul>
              </li>
            </ul>
           </div><!-- /.navbar-collapse -->
            </div><!-- /.container-fluid -->
          </nav>
        </div>
      </nav>
      <div class="navbar-offset"></div>
      <div id="map">
      </div>
      <div class="row main-row">
        <div class="col-sm-4 col-md-3 sidebar sidebar-left pull-left">
          <div class="panel-group sidebar-body" id="accordion-left">
            <div class="panel panel-default">
              <div class="panel-heading">
                <h4 class="panel-title">
                  <a data-toggle="collapse" href="#layers">
                    <i class="fa fa-list-alt"></i>
                    Layers
                  </a>
                  <span class="pull-right slide-submenu">
                    <i class="fa fa-chevron-left"></i>
                  </span>
                </h4>
              </div>
              <div id="layers" class="panel-collapse collapse in">
                <div class="panel-body list-group">
                  <a href="#" class="list-group-item">
                    <i class="fa fa-globe"></i> Open Street Map
                  </a>
                  <a href="#" class="list-group-item">
                    <i class="fa fa-globe"></i> Bing
                  </a>
                  <a href="#" class="list-group-item">
                    <i class="fa fa-globe"></i> WMS
                  </a>
                </div>
              </div>
            </div>
            <div class="panel panel-default">
              <div class="panel-heading">
                <h4 class="panel-title">
                  <a data-toggle="collapse" href="#properties">
                    <i class="fa fa-list-alt"></i>
                    Legend
                  </a>
                </h4>
              </div>
              <div id="properties" class="panel-collapse collapse in">
                <div class="panel-body">
                  <div id="mapLegendDiv"></div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-sm-4 col-md-6 mid"></div>
        <div class="col-sm-4 col-md-3 sidebar sidebar-right pull-right">
          <div class="panel-group sidebar-body" id="accordion-right">
            <div class="panel panel-default">
              <div class="panel-heading">
                <h4 class="panel-title">
                  <a data-toggle="collapse" href="#taskpane">
                    <i class="fa fa-tasks"></i>
                    Live Incident Feed
                  </a>
                  <span class="pull-right slide-submenu">
                    <i class="fa fa-chevron-right"></i>
                  </span>
                </h4>
              </div>
              <div id="taskpane" class="panel-collapse collapse in">
                <div class="panel-body">
                  <p align="justify">
                        <span style="font-weight:bold; color:red; text-decoration:underline">Bushfire Alert</span><br/>
                        The harmattan season is here again with the people in Northern Ghana and bushfires, which have become annual rituals, have started consuming the little vegetation that is left in this part of the country.
                  </p>
                  <p align="justify">
                        <span style="font-weight:bold; color:blue; text-decoration:underline">Overflowing Water</span><br/>
                        An underground pipe tube has been exposed and bursted. Water is flowing into the streets. This needs an immediate attention.
                  </p>
                </div>
              </div>
            </div>
            <div class="panel panel-default">
              <div class="panel-heading">
                <h4 class="panel-title">
                  <a data-toggle="collapse" href="#webmap">
                    <i class="fa fa-list-alt"></i>
                    Webmap Layers
                  </a>
                </h4>
              </div>
              <div id="webmap" class="panel-collapse collapse in">
                <div class="panel-body">
                    <div id="TableOfContents"></div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="mini-submenu mini-submenu-left pull-left">
        <i class="fa fa-list-alt"></i>
      </div>
      <div class="mini-submenu mini-submenu-right pull-right">
        <i class="fa fa-tasks"></i>
      </div>
    </div>
  </body>
</html>