// JavaScript Document

$(document).ready(function(e) {
	// ----------------------------------------------------------------------------
	// * call to initialize form
	// ----------------------------------------------------------------------------
	initializeForm();
	
	
	// ----------------------------------------------------------------------------
	// * validate the form input
	// ----------------------------------------------------------------------------
	$('#formPurchase').validate();
	
	// ----------------------------------------------------------------------------
	// * Saves order to database
	// ----------------------------------------------------------------------------
	$('#btnSave').click(function(){
		var urlOrder = '../order/index.php?op=receipt&action=save';
		var formOrder = $('#formReceipt').serialize();
		$.post(urlOrder,formOrder,processResponse).fail(function (err) {throw err;});
		
		function processResponse(data)
		{
			$('#message').html(data);		
		}
		
		// --- enable AddOrderItem button
		$('#AddReceiptItem').attr('disabled',false);
		
		// --- change save to update
		$('#btnSave').text('Update');
		return false;
	});
	
	
	
	// ----------------------------------------------------------------------------
	// * creates the order item dialog
	// ----------------------------------------------------------------------------
	$( "#formReceiptItem" ).dialog({ 
			autoOpen: false, 
			resizable: false,
			show: {
				effect: "blind",
				duration: 1000
			},
			hide: {
				effect: "explode",
				duration: 1000
			},
			width:500,
			modal:true,
			buttons: {
				"Save": function() {
					var urlOrder = '../order/index.php?op=purchaseItem&action=save';
					var formReceipt = $('#formReceiptItem').serialize();
					$.post(urlOrder,formReceipt,processResponse).fail(function (err) {throw err;});
					
					function processResponse(data)
					{
						$('#legItems').text(data);		
					}
					
					return false;
				},
				Cancel: function() {
					
					// --- populate data on grid.
					var orderCode = window.sessionStorage.OrderCode;
					var urlItem = '../order/index.php';
					var urlData = 'op=purchaseItem&action=list&id=' + orderCode;
		
					$.get(urlItem, urlData, processResponse).done(function(){
						// --- dynamically reload script to apply settings to grid
						$.getScript('../library/framework/js/awsJS.js');
					});
					
					function processResponse(data)
					{
						$('#divGrid').html(data);	
					}

					
					// --- close the dialog
					$( this ).dialog( "close" );
					
					// --- clear the order item form
					clearOrderItemForm();
					
					// --- show the summation panel
					$('#divSummation').show();
				}
			}
 	});
	
	
	// ----------------------------------------------------------------------------
	// * click event for AddOrderItem
	// * show add item dialog box
	// ----------------------------------------------------------------------------
	$('#AddReceiptItem').click(function(){
		$( "#formReceiptItem" ).dialog("open");
		
		// --- get the order item code
		var urlItem = '../library/framework/systemNumber.inc.php';
		var urlData = 'mod=order_item';
		
		$.get(urlItem, urlData, processResponse);
		
		function processResponse(data)
		{
			$('#itxtOrderItemCode').val(data).attr('readonly', 'readonly');	
		}
		
		// --- set purchase order code
		$('#itxtPurchaseOrderNo').val(window.sessionStorage.OrderCode).attr('readonly', 'readonly');
		
		// --- disable form elements
		$('#itxtTaxAmount').attr('readonly', 'readonly');	
		
		// --- set legend caption
		$('#legItems').text('Add Order Item');
		
		return false;
	});
	
	
	// ----------------------------------------------------------------------------
	// * click event for Stock Item Select
	// * populates the item cost
	// ----------------------------------------------------------------------------
	$('#icboStockItem').click(function (){
		
		var itemid = $(this).val();
		var url = '../library/framework/json.php';
		var param = 'op=inventory_cost&ptr=' + itemid;
		var itemCost;
		
		
		// hack to execute ajax synchronously(use $.ajax and set async:false).
		$.ajax({
			url:url+'?'+param,
			async:false,
			type:"get",
			success:function(data){
				itemCost = Number(data);
			}
		});
		
		// --- set value of item cost
		$('#itxtUnitCost').val(itemCost.toFixed(2));
	});
	
	
	// ----------------------------------------------------------------------------
	// * blur event for unit cost
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#itxtUnitCost').blur(function(){
		var valCost = $(this).val();
		var valQty = $('#itxtQuantity').val();
		
		var valTotal = calculateTotal(valCost, valQty);
		
		$('#itxtTotalPrice').val(valTotal).text(valTotal);
	});
	
	
	// ----------------------------------------------------------------------------
	// * click event for quantity
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#itxtQuantity').click(function(){
		var valQty = $(this).val();
		var valCost = $('#itxtUnitCost').val();
		
		if (valCost != '')
		{
			var valTotal = calculateTotal(valCost, valQty);
			$('#itxtTotalPrice').val(valTotal).text(valTotal);
		}
	});
	
	
	// ----------------------------------------------------------------------------
	// * change event for TAX
	// * calculates the total cost of item
	// ----------------------------------------------------------------------------
	$('#cboPO').change(function(){
		var code = $(this).val();
		var path = '../library/framework/json.php';
		var param = 'op=orderHeader&ptr='+code;
		var url = path+'?'+param;
		var supplier = '', term = '', oDate = '';
		
		$.getJSON(path, param, processResult);
		
		function processResult(data)
		{
			$.each(data, function (index, Info){
				$('#cboSupplier').val(Info.SUPPLIER_ROWID_FK);
				$('#cboPaymentTerm').val(Info.PAYMENT_TERM_ROWID_FK);
				window.sessionStorage.OrderDate = Info.ORDER_DATE;
			});
		}
		
		// --- calculate the turn around days
		var _orderDate = new Date(window.sessionStorage.OrderDate);
		var _receiptDate = new Date($('#datReceiptDate').val());
		
	
		
		alert (window.sessionStorage.OrderDate);
		
		$('#txtTurnAround').val(calcTurnAround(_orderDate, _receiptDate));
		
		return false;
	});
	

	
	// ----------------------------------------------------------------------------
	// * Check if Receive date is lower than date of order
	// ----------------------------------------------------------------------------
	$('#datReceiveDate').blur(function(){
		var dateReceive = $(this).val();
		var dateOrder = $('#datOrderDate').val();
		
		if (dateReceive < dateOrder)
		{
			alert('Receive date is older than Order date !');
			$(this).focus();
		}
	});
	
	
	// ----------------------------------------------------------------------------
	// * Initialize form
	// ----------------------------------------------------------------------------
	function initializeForm()
	{
		// --- session variable to set order coede
		window.sessionStorage.ReceiptCode = $('#txtReceiptNo').val();
		window.sessionStorage.TaxRate='';
		
		// --- hide summation panel
		//$('#divSummation').hide();
		
		// --- reset form variables
		$('#itxtQuantity').val(1);
		$('#taxRate').val(0.0);
		$('#txtFreight').val(0.0);	
	}
	
	
	// ----------------------------------------------------------------------------
	// * Clear Order Item Form for new entry
	// ----------------------------------------------------------------------------
	function clearOrderItemForm()
	{
		$('#itxtQuantity').val('');
		$('#icboStockItem').val(0);
		$('#itxtUnitCost').val('');
		$('#icboTax').val(0);
		$('#itxtTaxAmount').val('');
		$('#itxtTotalPrice').val('');
		$('#itxtNotes').val('');
	}
	
	
	// ----------------------------------------------------------------------------
	// * Calculate turn around days for order received
	// ----------------------------------------------------------------------------
	function calcTurnAround(dtOrderDate, dtReceiptDate)
	{
		var turnAround = new Date(dtReceiptDate - dtOrderDate);
		return turnAround.getDay() + ' Days';	
	}
});
